Package org.opensaml.saml.saml2.metadata

# Interface EntityDescriptor

All Superinterfaces:
  `AttributeExtensibleXMLObject`, `CacheableSAMLObject`, `SAMLObject`, `SignableSAMLObject`, `SignableXMLObject`, `TimeBoundSAMLObject`, `XMLObject`

All Known Implementing Classes:
  `EntityDescriptorImpl`

public interface EntityDescriptor extends SignableSAMLObject, TimeBoundSAMLObject, CacheableSAMLObject, AttributeExtensibleXMLObject
SAML 2.0 Metadata EntityDescriptor.

## Field Summary

Fields
Modifier and Type
Field
Description
`static final String`
`DEFAULT_ELEMENT_LOCAL_NAME`
Element name, no namespace.
`static final QName`
`DEFAULT_ELEMENT_NAME`
Default element name.
`static final QName`
`ELEMENT_QNAME`
Element QName, no prefix.
`static final String`
`ENTITY_ID_ATTRIB_NAME`
"Name" attribute name.
`static final String`
`ID_ATTRIB_NAME`
"ID" attribute name.
`static final String`
`TYPE_LOCAL_NAME`
Local name of the XSI type.
`static final QName`
`TYPE_NAME`
QName of the XSI type.

### Fields inherited from interface org.opensaml.saml.saml2.common.CacheableSAMLObject

`CACHE_DURATION_ATTRIB_NAME, CACHE_DURATION_ATTRIB_QNAME`

### Fields inherited from interface org.opensaml.saml.saml2.common.TimeBoundSAMLObject

`VALID_UNTIL_ATTRIB_NAME, VALID_UNTIL_ATTRIB_QNAME`

## Method Summary

Modifier and Type
Method
Description
`List<AdditionalMetadataLocation>`
`getAdditionalMetadataLocations()`
Gets the additional metadata locations for this entity.
`AffiliationDescriptor`
`getAffiliationDescriptor()`
Gets the affiliation descriptor for this entity.
`AttributeAuthorityDescriptor`
`getAttributeAuthorityDescriptor(String supportedProtocol)`
Gets the first `AttributeAuthorityDescriptor` role descriptor for this entity that supports the given protocol.
`AuthnAuthorityDescriptor`
`getAuthnAuthorityDescriptor(String supportedProtocol)`
Gets the first `AuthnAuthorityDescriptor` role descriptor for this entity that supports the given protocol.
`List<ContactPerson>`
`getContactPersons()`
Get the contact people for this entity.
`String`
`getEntityID()`
Gets the entity ID for this entity descriptor.
`Extensions`
`getExtensions()`
Gets the Extensions child of this object.
`String`
`getID()`
Gets the ID for this entity descriptor.
`IDPSSODescriptor`
`getIDPSSODescriptor(String supportedProtocol)`
Gets the first `IDPSSODescriptor` role descriptor for this entity that supports the given protocol.
`Organization`
`getOrganization()`
Gets the organization for this entity.
`PDPDescriptor`
`getPDPDescriptor(String supportedProtocol)`
Gets the first `PDPDescriptor` role descriptor for this entity that supports the given protocol.
`List<RoleDescriptor>`
`getRoleDescriptors()`
Gets all the role descriptors for this entity descriptor.
`List<RoleDescriptor>`
`getRoleDescriptors(QName typeOrName)`
Gets all the role descriptors for this entity descriptor that match the supplied QName parameter.
`List<RoleDescriptor>`
`getRoleDescriptors(QName typeOrName, String supportedProtocol)`
Gets all the role descriptors for this entity that support the given protocol.
`SPSSODescriptor`
`getSPSSODescriptor(String supportedProtocol)`
Gets the first `SPSSODescriptor` role descriptor for this entity that supports the given protocol.
`void`
`setAffiliationDescriptor(AffiliationDescriptor descriptor)`
Sets the affiliation descriptor for this entity.
`void`
`setEntityID(String id)`
Sets the entity ID for this entity descriptor.
`void`
`setExtensions(Extensions extensions)`
Sets the Extensions child of this object.
`void`
`setID(String newID)`
Sets the ID for this entity descriptor.
`void`
`setOrganization(Organization organization)`
Sets the organization for this entity.

### Methods inherited from interface org.opensaml.core.xml.AttributeExtensibleXMLObject

`getUnknownAttributes`

### Methods inherited from interface org.opensaml.saml.saml2.common.CacheableSAMLObject

`getCacheDuration, setCacheDuration`

### Methods inherited from interface org.opensaml.saml.common.SignableSAMLObject

`getSignatureReferenceID`

### Methods inherited from interface org.opensaml.xmlsec.signature.SignableXMLObject

`getSignature, isSigned, setSignature`

### Methods inherited from interface org.opensaml.saml.saml2.common.TimeBoundSAMLObject

`getValidUntil, isValid, setValidUntil`

### Methods inherited from interface org.opensaml.core.xml.XMLObject

`detach, ensureDOM, getDOM, getElementQName, getIDIndex, getNamespaceManager, getNamespaces, getNoNamespaceSchemaLocation, getObjectMetadata, getOrderedChildren, getParent, getSchemaLocation, getSchemaType, hasChildren, hasParent, isNil, isNilXSBoolean, releaseChildrenDOM, releaseDOM, releaseParentDOM, resolveID, resolveIDFromRoot, setDOM, setNil, setNil, setNoNamespaceSchemaLocation, setParent, setSchemaLocation`

## Field Details

### DEFAULT_ELEMENT_LOCAL_NAME

@Nonnull @NotEmpty static final String DEFAULT_ELEMENT_LOCAL_NAME
Element name, no namespace.

See Also:
  - Constant Field Values

### DEFAULT_ELEMENT_NAME

@Nonnull static final QName DEFAULT_ELEMENT_NAME
Default element name.

### TYPE_LOCAL_NAME

@Nonnull @NotEmpty static final String TYPE_LOCAL_NAME
Local name of the XSI type.

See Also:
  - Constant Field Values

### TYPE_NAME

@Nonnull static final QName TYPE_NAME
QName of the XSI type.

### ELEMENT_QNAME

@Nonnull static final QName ELEMENT_QNAME
Element QName, no prefix.

### ID_ATTRIB_NAME

@Nonnull @NotEmpty static final String ID_ATTRIB_NAME
"ID" attribute name.

See Also:
  - Constant Field Values

### ENTITY_ID_ATTRIB_NAME

@Nonnull @NotEmpty static final String ENTITY_ID_ATTRIB_NAME
"Name" attribute name.

See Also:
  - Constant Field Values

## Method Details

### getEntityID

@Nullable String getEntityID()
Gets the entity ID for this entity descriptor.

Returns:
  the entity ID for this entity descriptor

### setEntityID

void setEntityID(@Nullable String id)
Sets the entity ID for this entity descriptor.

Parameters:
  `id` - the entity ID for this entity descriptor

### getID

@Nullable String getID()
Gets the ID for this entity descriptor.

Returns:
  the ID for this entity descriptor

### setID

void setID(@Nullable String newID)
Sets the ID for this entity descriptor.

Parameters:
  `newID` - the ID for this entity descriptor

### getExtensions

@Nullable Extensions getExtensions()
Gets the Extensions child of this object.

Returns:
  the Extensions child of this object

### setExtensions

void setExtensions(@Nullable Extensions extensions)
Sets the Extensions child of this object.

Parameters:
  `extensions` - the Extensions child of this object

### getRoleDescriptors

@Nonnull @Live List<RoleDescriptor> getRoleDescriptors()
Gets all the role descriptors for this entity descriptor.

Returns:
  the role descriptors for this entity descriptor

### getRoleDescriptors

@Nonnull @Live List<RoleDescriptor> getRoleDescriptors(@Nonnull QName typeOrName)
Gets all the role descriptors for this entity descriptor that match the supplied QName parameter.

Parameters:
  `typeOrName` - the name of the role
Returns:
  the role descriptors for this entity descriptor

### getRoleDescriptors

@Nonnull @Unmodifiable @NotLive List<RoleDescriptor> getRoleDescriptors(@Nonnull QName typeOrName, @Nonnull @NotEmpty String supportedProtocol)
Gets all the role descriptors for this entity that support the given protocol.

Parameters:
  `typeOrName` - the name of the role
  `supportedProtocol` - the supported protocol
Returns:
  the list of role descriptors that support the given protocol

### getIDPSSODescriptor

@Nullable IDPSSODescriptor getIDPSSODescriptor(@Nonnull @NotEmpty String supportedProtocol)
Gets the first `IDPSSODescriptor` role descriptor for this entity that supports the given protocol.

Parameters:
  `supportedProtocol` - protocol that must be supported
Returns:
  the `IDPSSODescriptor` role descriptor

### getSPSSODescriptor

@Nullable SPSSODescriptor getSPSSODescriptor(@Nonnull @NotEmpty String supportedProtocol)
Gets the first `SPSSODescriptor` role descriptor for this entity that supports the given protocol.

Parameters:
  `supportedProtocol` - protocol that must be supported
Returns:
  the `SPSSODescriptor` role descriptor

### getAuthnAuthorityDescriptor

@Nullable AuthnAuthorityDescriptor getAuthnAuthorityDescriptor(@Nonnull @NotEmpty String supportedProtocol)
Gets the first `AuthnAuthorityDescriptor` role descriptor for this entity that supports the given protocol.

Parameters:
  `supportedProtocol` - protocol that must be supported
Returns:
  the `AuthnAuthorityDescriptor` role descriptor

### getAttributeAuthorityDescriptor

@Nullable AttributeAuthorityDescriptor getAttributeAuthorityDescriptor(@Nonnull @NotEmpty String supportedProtocol)
Gets the first `AttributeAuthorityDescriptor` role descriptor for this entity that supports the given protocol.

Parameters:
  `supportedProtocol` - protocol that must be supported
Returns:
  the `AttributeAuthorityDescriptor` role descriptor

### getPDPDescriptor

@Nullable PDPDescriptor getPDPDescriptor(@Nonnull @NotEmpty String supportedProtocol)
Gets the first `PDPDescriptor` role descriptor for this entity that supports the given protocol.

Parameters:
  `supportedProtocol` - protocol that must be supported
Returns:
  the `PDPDescriptor` role descriptor

### getAffiliationDescriptor

@Nullable AffiliationDescriptor getAffiliationDescriptor()
Gets the affiliation descriptor for this entity.

Returns:
  the affiliation descriptor for this entity

### setAffiliationDescriptor

void setAffiliationDescriptor(@Nullable AffiliationDescriptor descriptor)
Sets the affiliation descriptor for this entity.

Parameters:
  `descriptor` - the affiliation descriptor for this entity

### getOrganization

@Nullable Organization getOrganization()
Gets the organization for this entity.

Returns:
  the organization for this entity

### setOrganization

void setOrganization(@Nullable Organization organization)
Sets the organization for this entity.

Parameters:
  `organization` - the organization for this entity

### getContactPersons

@Nonnull @Live List<ContactPerson> getContactPersons()
Get the contact people for this entity.

Returns:
  the contact people for this entity

### getAdditionalMetadataLocations

@Nonnull @Live List<AdditionalMetadataLocation> getAdditionalMetadataLocations()
Gets the additional metadata locations for this entity.

Returns:
  the additional metadata locations for this entity